#include <iostream>
#include "menu.h"

using namespace std;

Menu::Menu()
{
	cout << "Udvozollek a Lista tesztelo alkalmazasban!" << endl;
}

void Menu::run()
{
	int option = 0;
	do
	{
		menuWrite();
		option = getInteger("Valasztott menupont: ");

		switch(option)
		{
			case 1:
				testAppend();
				break;
			case 2:
				testPrepend();
				break;
			case 3:
				testPop();
				break;
			case 4:
				testMax();
				break;
			case 5:
				testPrint();
				break;
		}
	}
	while(option != 0);
}

void Menu::menuWrite() const
{
	cout << endl << endl;
	cout << "--- MENU ---" << endl;
	cout << "Valassz az alabbi opciok kozul!" << endl;
	cout << "\t1 - Elem hozzafuzese a lancolt lista vegere" << endl;
	cout << "\t2 - Elem hozzafuzese a lancolt lista elejere" << endl;
	cout << "\t3 - Elem kivetele a lancolt lista elejerol" << endl;
	cout << "\t4 - Maximalis ertek megkeresese" << endl;
	cout << "\t5 - Lancolt lista kiirasa" << endl;
	cout << "\t0 - Kilepes" << endl;
}

int Menu::getInteger(const string& msg) const
{
	int number;
	bool error;
	do
	{
		cout << msg;
		cin >> number;
		if(cin.fail())
		{
			cin.clear();
			cin.ignore(256, '\n');
			cout << "A megadott ertek nem egesz szam!" << endl;
			error = true;
        }
		else
            error = false;
    }
    while(error);
	return number;
}

void Menu::testAppend()
{
	cout << endl;
	cout << "Elem hozzafuzese a lancolt lista vegere" << endl;
	int v = getInteger("v := ");
	_list.append(v);
	cout << "Lista: " << _list << endl;
}

void Menu::testPrepend()
{
	cout << endl;
	cout << "Elem hozzafuzese a lancolt lista elejere" << endl;
	int v = getInteger("v := ");
	_list.prepend(v);
	cout << "Lista: " << _list << endl;
}

void Menu::testPop()
{
	cout << endl;
	cout << "Elem kivetele a lancolt lista elejerol" << endl;
	try
	{
		int first = _list.pop();
		cout << "Kivett elem: " << first << endl;
		cout << "Lista: " << _list << endl;
	}
	catch(List::Exception ex)
	{
		if(ex == List::Empty)
			cout << "Hiba: a lista ures!" << endl;
		else
			cout << "Nem vart hiba!" << endl;
	}
}

void Menu::testMax()
{
	cout << endl;
	cout << "Maximalis ertek megkeresese" << endl;
	try
	{
		int max = _list.getMax();
		cout << "Maximalis ertek: " << max << endl;
	}
	catch(List::Exception ex)
	{
		if(ex == List::Empty)
			cout << "Hiba: a lista ures!" << endl;
		else
			cout << "Nem vart hiba!" << endl;
	}
}

void Menu::testPrint()
{
	cout << endl;
	cout << "Lancolt lista kiirasa" << endl;
	cout << "Lista: " << _list << endl;
}
